/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef NMM_IDVDNavImpl_HPP
#define NMM_IDVDNavImpl_HPP

#include "nmm/nmm_prefix.hpp"

#include "nmm/comm/NMMObject.hpp"
#include "IDVDNav.hpp"


#include "visibility.hpp"

namespace NMM
{

  class DLLEXPORT IDVDNavImpl  : public virtual NMM::NMMObject { 
  public:
    IDVDNavImpl() { addInterface(new IDVDNav(*this)); registerEvents(); };

    virtual ~IDVDNavImpl() {};

  protected:

    virtual Result selectButton(const nmm_int32& button) = 0;

    virtual Result activateButton(const nmm_int32& button) = 0;

    virtual Result activateSelectedButton() = 0;

    virtual Result goUp() = 0;

    virtual Result buttonUp() = 0;

    virtual Result buttonDown() = 0;

    virtual Result buttonRight() = 0;

    virtual Result buttonLeft() = 0;

    virtual nmm_int32 getSelectedButton() = 0;


  private:
    void registerEvents();
  };

}

#include "nmm/nmm_suffix.hpp"

#endif
